<?php

namespace CTT\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPIPAuthorizationData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPIPAuthorizationData
 * @subpackage Arrays
 */
class ArrayOfPIPAuthorizationData extends AbstractStructArrayBase
{
    /**
     * The PIPAuthorizationData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CTT\StructType\PIPAuthorizationData[]
     */
    public $PIPAuthorizationData;
    /**
     * Constructor method for ArrayOfPIPAuthorizationData
     * @uses ArrayOfPIPAuthorizationData::setPIPAuthorizationData()
     * @param \CTT\StructType\PIPAuthorizationData[] $pIPAuthorizationData
     */
    public function __construct(array $pIPAuthorizationData = array())
    {
        $this
            ->setPIPAuthorizationData($pIPAuthorizationData);
    }
    /**
     * Get PIPAuthorizationData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CTT\StructType\PIPAuthorizationData[]|null
     */
    public function getPIPAuthorizationData()
    {
        return isset($this->PIPAuthorizationData) ? $this->PIPAuthorizationData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPIPAuthorizationData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPIPAuthorizationData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePIPAuthorizationDataForArrayConstraintsFromSetPIPAuthorizationData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPIPAuthorizationDataPIPAuthorizationDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPIPAuthorizationDataPIPAuthorizationDataItem instanceof \CTT\StructType\PIPAuthorizationData) {
                $invalidValues[] = is_object($arrayOfPIPAuthorizationDataPIPAuthorizationDataItem) ? get_class($arrayOfPIPAuthorizationDataPIPAuthorizationDataItem) : sprintf('%s(%s)', gettype($arrayOfPIPAuthorizationDataPIPAuthorizationDataItem), var_export($arrayOfPIPAuthorizationDataPIPAuthorizationDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PIPAuthorizationData property can only contain items of type \CTT\StructType\PIPAuthorizationData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PIPAuthorizationData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CTT\StructType\PIPAuthorizationData[] $pIPAuthorizationData
     * @return \CTT\ArrayType\ArrayOfPIPAuthorizationData
     */
    public function setPIPAuthorizationData(array $pIPAuthorizationData = array())
    {
        // validation for constraint: array
        if ('' !== ($pIPAuthorizationDataArrayErrorMessage = self::validatePIPAuthorizationDataForArrayConstraintsFromSetPIPAuthorizationData($pIPAuthorizationData))) {
            throw new \InvalidArgumentException($pIPAuthorizationDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pIPAuthorizationData) || (is_array($pIPAuthorizationData) && empty($pIPAuthorizationData))) {
            unset($this->PIPAuthorizationData);
        } else {
            $this->PIPAuthorizationData = $pIPAuthorizationData;
        }
        return $this;
    }
    /**
     * Add item to PIPAuthorizationData value
     * @throws \InvalidArgumentException
     * @param \CTT\StructType\PIPAuthorizationData $item
     * @return \CTT\ArrayType\ArrayOfPIPAuthorizationData
     */
    public function addToPIPAuthorizationData(\CTT\StructType\PIPAuthorizationData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CTT\StructType\PIPAuthorizationData) {
            throw new \InvalidArgumentException(sprintf('The PIPAuthorizationData property can only contain items of type \CTT\StructType\PIPAuthorizationData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PIPAuthorizationData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CTT\StructType\PIPAuthorizationData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CTT\StructType\PIPAuthorizationData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CTT\StructType\PIPAuthorizationData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CTT\StructType\PIPAuthorizationData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CTT\StructType\PIPAuthorizationData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PIPAuthorizationData
     */
    public function getAttributeName()
    {
        return 'PIPAuthorizationData';
    }
}
